'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var checkArray = function checkArray(val) {
    if (!Array.isArray(val)) {
        throw Error('value must be an array');
    }
};

module.exports = {
    toArray: function toArray(arraylike) {
        return [].concat(_toConsumableArray(arraylike));
    },

    ensureArray: function ensureArray() {
        var val = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        return Array.isArray(val) ? val : [val];
    },

    head: function head(ar) {
        checkArray(ar);

        var _ar = _toArray(ar),
            head = _ar[0],
            rest = _ar.slice(1);

        return head;
    },
    tail: function tail(ar) {
        checkArray(ar);

        var _ar$slice = ar.slice(-1),
            _ar$slice2 = _slicedToArray(_ar$slice, 1),
            tail = _ar$slice2[0];

        return tail;
    },
    unique: function unique(ar) {
        checkArray(ar);
        return ar.filter(function (val, i, input) {
            return i === input.indexOf(val);
        });
    },


    flatten: function flatten(ar) {
        checkArray(ar);

        return ar.reduce(function (acc, item) {
            if (Array.isArray(item)) {
                acc.push.apply(acc, _toConsumableArray(flatten(item)));
            } else {
                acc.push(item);
            }

            return acc;
        }, []);
    }
};