'use strict';

var fs = require('fs');

module.exports = {
    readFile: function readFile(filename) {
        return new Promise(function (resolve, reject) {
            fs.readFile(filename, function (err, data) {
                if (err) {
                    reject(err);
                } else {
                    resolve(data);
                }
            });
        });
    },

    writeFile: function writeFile(filename, data) {
        return new Promise(function (resolve, reject) {
            fs.writeFile(filename, data, function (err) {
                if (err) {
                    reject(err);
                } else {
                    resolve();
                }
            });
        });
    }
};