'use strict';

module.exports = {
    prop: function prop(_prop) {
        return function (obj) {
            return obj[_prop];
        };
    },

    filter: function filter(obj, pred) {
        return Object.keys(obj).reduce(function (filtered, key) {
            var value = obj[key];

            if (pred(key, value)) {
                filtered[key] = value;
            }

            return filtered;
        }, {});
    },
    defaults: function defaults(obj, values) {
        Object.keys(values).forEach(function (key) {
            if (!obj.hasOwnProperty(key)) {
                obj[key] = values[key];
            }
        });
    }
};